Loading...
Searching...
No Matches
hueplusplus::sensors::ZLLTemperature Class Reference

ZigBee temperature sensor. More...

`#include <hueplusplus/ZLLSensors.h>`

Inheritance diagram for hueplusplus::sensors::ZLLTemperature:
[legend]
Collaboration diagram for hueplusplus::sensors::ZLLTemperature:
[legend]

## Public Member Functions

| ZLLTemperature (Sensor sensor)
| Construct from generic sensor.
bool | isOn () const
| Check if sensor is on.
void | setOn (bool on)
| Enable or disable sensor.
bool | hasBatteryState () const
| Check whether the sensor has a battery state.
int | getBatteryState () const
| Get battery state.
Alert | getLastAlert () const
| Get last sent alert.
void | sendAlert (Alert type)
| Send alert.
bool | isReachable () const
| Check whether the sensor is reachable.
int | getTemperature () const
| Get recorded temperature.
time::AbsoluteTime | getLastUpdated () const
| Get time of last status update.
Public Member Functions inherited from hueplusplus::BaseDevice
virtual | ~BaseDevice ()=default
| Virtual destructor.
virtual int | getId () const
| Const function that returns the id of this device.
virtual std::string | getType () const
| Const function that returns the device type.
virtual std::string | getName ()
| Function that returns the name of the device.
virtual std::string | getName () const
| Const function that returns the name of the device.
virtual std::string | getModelId () const
| Const function that returns the modelid of the device.
virtual std::string | getUId () const
| Const function that returns the uniqueid of the device.
virtual std::string | getManufacturername () const
| Const function that returns the manufacturername of the device.
virtual std::string | getProductname () const
| Const function that returns the productname of the device.
virtual std::string | getSwVersion ()
| Function that returns the software version of the device.
virtual std::string | getSwVersion () const
| Const function that returns the software version of the device.
virtual bool | setName (const std::string &name)
| Function that sets the name of the device.
virtual void | refresh (bool force=false)
| Refreshes internal cached state.
virtual void | setRefreshDuration (std::chrono::steady_clock::duration refreshDuration)
| Sets custom refresh interval for this device.

## Static Public Attributes

static constexpr const char * | typeStr = "ZLLTemperature"
| ZLLTemperature sensor type name.

## Additional Inherited Members

Protected Member Functions inherited from hueplusplus::BaseDevice
| BaseDevice (int id, const std::shared_ptr< APICache > &baseCache)
| Protected ctor that is used by subclasses, construct with shared cache.
| BaseDevice (int id, const HueCommandAPI &commands, const std::string &path, std::chrono::steady_clock::duration refreshDuration, const nlohmann::json &currentState)
| Protected ctor that is used by subclasses.
virtual nlohmann::json | sendPutRequest (const std::string &subPath, const nlohmann::json &request, FileInfo fileInfo)
| Utility function to send a put request to the device.
Protected Attributes inherited from hueplusplus::BaseDevice
int | id
| holds the id of the device
APICache | state
| holds the current state of the device

## Detailed Description

ZigBee temperature sensor.

## Constructor & Destructor Documentation

## ZLLTemperature()

hueplusplus::sensors::ZLLTemperature::ZLLTemperature | ( | Sensor | sensor | ) |

inline explicit

Construct from generic sensor.

## Member Function Documentation

## getBatteryState()

int hueplusplus::sensors::ZLLTemperature::getBatteryState | ( |  | ) | const

Get battery state.

Returns
  Battery state in percent

## getLastAlert()

Alert hueplusplus::sensors::ZLLTemperature::getLastAlert | ( |  | ) | const

Get last sent alert.

Note
  This is not cleared when the alert ends.

## getLastUpdated()

time::AbsoluteTime hueplusplus::sensors::ZLLTemperature::getLastUpdated | ( |  | ) | const

Get time of last status update.

Returns
  The last update time, or a time with a zero duration from epoch if the last update time is not set.

## getTemperature()

int hueplusplus::sensors::ZLLTemperature::getTemperature | ( |  | ) | const

Get recorded temperature.

Returns
  Temperature in 0.01 degrees Celsius.

## hasBatteryState()

bool hueplusplus::sensors::ZLLTemperature::hasBatteryState | ( |  | ) | const

Check whether the sensor has a battery state.

## isOn()

bool hueplusplus::sensors::ZLLTemperature::isOn | ( |  | ) | const

Check if sensor is on.

Sensors which are off do not change their status

## isReachable()

bool hueplusplus::sensors::ZLLTemperature::isReachable | ( |  | ) | const

Check whether the sensor is reachable.

## sendAlert()

void hueplusplus::sensors::ZLLTemperature::sendAlert | ( | Alert | type | ) |

Send alert.

Exceptions

  std::system_error | when system or socket operations fail
  HueException | when response contained no body
  HueAPIResponseException | when response contains an error
  nlohmann::json::parse_error | when response could not be parsed

## setOn()

void hueplusplus::sensors::ZLLTemperature::setOn | ( | bool | on | ) |

Enable or disable sensor.

Exceptions

  std::system_error | when system or socket operations fail
  HueException | when response contained no body
  HueAPIResponseException | when response contains an error
  nlohmann::json::parse_error | when response could not be parsed

## Member Data Documentation

## typeStr

constexpr const char * hueplusplus::sensors::ZLLTemperature::typeStr = "ZLLTemperature"

static constexpr

ZLLTemperature sensor type name.

The documentation for this class was generated from the following files:

- include/hueplusplus/ZLLSensors.h
- src/ZLLSensors.cpp